package cds.map.jel;

import gnu.jel.CompilationException;

public class ExpressionsJel {
	public static  String computeExpression(String expr){
		
		String r=null;
		try{
		//**********************************************************
		//**** to use JEL we first have to define the namespace ****

		// we shall export the static methods of java.lang.Math and map.Maths
		Class[] stLib=new Class[2];
		stLib[0]=java.lang.Math.class;
		
		stLib[1]=cds.map.jel.Maths.class;
		

		// we shall enable access to methods of two classes
		Class[] dynLib=new Class[1];
		// we export YYY getXXXProperty() methods for dynamic variable access
		dynLib[0]=MyResolverProvider.class;

		// this initializes the resolver object
		MyResolverProvider resolver=new MyResolverProvider();

		// we shall allow dot operators on strings and data
		Class[] dotLib=new Class[1];
		dotLib[0]=java.lang.String.class;
		
		// finally, the namespace is defined by constructing the library class
		gnu.jel.Library lib=
		    new gnu.jel.Library(stLib,dynLib,dotLib,resolver,null);


		//**********************************************************
		//******** Now we setup the global context and data  *******

		Object[] context=new Object[1];
		context[0]=resolver; // this pointer for YYY getXXXProperty() methos


		//**********************************************************
		//******** We are ready to compile some expressions  *******
		gnu.jel.CompiledExpression compiledExpr;
		
		compiledExpr=gnu.jel.Evaluator.compile(expr,lib);

		r=compiledExpr.evaluate(context).toString();
	}
		catch(CompilationException exp){
			r=expr;
		}
		catch(Throwable e){}
	

		return r;
		
	}
	
	public static void main(String[] args) {
	String s=computeExpression("min(1,2,3,4,5,2,2)");
	s=computeExpression("min(4.72642829485e-06*(-2001.48681333)+-1.3060659854e-05*(-1147.65841523)+53.23916133642,4.72642829485e-06*(-2001.48681333)+-1.3060659854e-05*(4354-1147.65841523)+53.23916133642,4.72642829485e-06*(4238-2001.48681333)+-1.3060659854e-05*-(1147.65841523)+53.23916133642,4.72642829485e-06*(4238-2001.48681333)+-1.3060659854e-05*(4354-1147.65841523)+53.23916133642)");
	s=computeExpression("min(1+2,36-234,33,12)");
	s=computeExpression("min(4.72642829485e-06*(-2001.48681333)+-1.3060659854e-05*(-1147.65841523)+53.23916133642,4.72642829485e-06*(-2001.48681333)+-1.3060659854e-05*(4354-1147.65841523)+53.23916133642,4.72642829485e-06*(4238-2001.48681333)+-1.3060659854e-05*-(1147.65841523)+53.23916133642,4.72642829485e-06*(4238-2001.48681333)+-1.3060659854e-05*(4354-1147.65841523)+53.23916133642)");
	s=computeExpression("mod(6.4,5)");
	System.out.println(s);
	
	
	}
}
